package com.glxp.mipsdl.admin.client.file;

import com.glxp.mipsdl.admin.client.BaseFileClient;
import com.glxp.mipsdl.admin.entity.yxzyy.YxzyyProductEntity;
import com.glxp.mipsdl.admin.req.system.PostThrProductsRequest;
import com.glxp.mipsdl.admin.res.system.UdiwmsProductInfoResponse;
import com.glxp.mipsdl.admin.thread.system.UdiInfoUploadService;
import com.glxp.mipsdl.common.res.BaseResponse;
import com.glxp.mipsdl.common.util.ExcelUtil;
import com.glxp.mipsdl.common.util.ResultVOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * 云霄中医院规范
 */
@Service
public class YxzFileClient implements BaseFileClient {

    Logger logger = LoggerFactory.getLogger(YxzFileClient.class);
    @Resource
    private UdiInfoUploadService udiInfoUploadService;


    @Override
    public BaseResponse uploadPi(List<MultipartFile> files, String thirdSys) {
        for (int i = 0; i < files.size(); i++) {
            MultipartFile file = files.get(i);
            if (file.isEmpty()) {
                return ResultVOUtils.error(500, "上传第" + (i++) + "个文件失败");
            }
            try {
                InputStream inputStream = file.getInputStream();
                ExcelUtil<YxzyyProductEntity> util = new ExcelUtil(YxzyyProductEntity.class);
                List<YxzyyProductEntity> yxzyyProductEntities = util.importExcel("耗材目录表", inputStream);
                List<UdiwmsProductInfoResponse> udiwmsProductInfoResponses = new ArrayList<>();
                for (YxzyyProductEntity yxzyyProductEntity : yxzyyProductEntities) {
                    UdiwmsProductInfoResponse udiwmsProductInfoResponse = new UdiwmsProductInfoResponse();
                    BeanUtils.copyProperties(yxzyyProductEntity, udiwmsProductInfoResponse);
                    //合并材料规格和材料型号两列数据为规格型号
                    udiwmsProductInfoResponse.setSpec(yxzyyProductEntity.getSpec() + yxzyyProductEntity.getModel());
                    udiwmsProductInfoResponses.add(udiwmsProductInfoResponse);
                }
                PostThrProductsRequest postThrProductsRequest = new PostThrProductsRequest();
                postThrProductsRequest.setDatas(udiwmsProductInfoResponses);
                postThrProductsRequest.setUploadType("文件导入");
                postThrProductsRequest.setThirdSys(thirdSys);
                udiInfoUploadService.postProducts(postThrProductsRequest);
                logger.error("上传完" + System.currentTimeMillis());
            } catch (IOException e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            } catch (Exception e) {
                e.printStackTrace();
                return ResultVOUtils.error(500, "数据异常");
            }
        }
        return ResultVOUtils.success("文件解析成功，正在上传，请稍后刷新查看");
    }

    @Override
    public BaseResponse uploadCorps(List<MultipartFile> files, String thirdSys) {
        return ResultVOUtils.error(500, "暂不支持往来单位上传！");
    }

    @Override
    public BaseResponse uploadInvPi(List<MultipartFile> files, String thirdSys) {
        return ResultVOUtils.error(500, "暂不支持库存产品信息上传！");
    }

    @Override
    public BaseResponse uploadOrders(List<MultipartFile> files, String thirdSys) {
        return ResultVOUtils.error(500, "暂不支持业务单据上传！");
    }

}
