package com.glxp.mipsdl.admin.controller;

import cn.hutool.core.util.StrUtil;
import com.glxp.mipsdl.admin.http.UdiwmsClient;
import com.glxp.mipsdl.admin.req.ThirdFilterInvRequest;
import com.glxp.mipsdl.common.res.BaseResponse;
import com.glxp.mipsdl.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 被动查询
 */

@RestController
public class ThirdGetController {


    @Resource
    UdiwmsClient udiwmsClient;


    @PostMapping("/udiwms/inv/products/filter")
    public BaseResponse filterInv(@RequestBody ThirdFilterInvRequest thirdFilterInvRequest) {

        if (thirdFilterInvRequest == null)
            return ResultVOUtils.error(500, "查询条件不能为空！");


        if (StrUtil.isEmpty(thirdFilterInvRequest.getBatchNo()) &&
                StrUtil.isEmpty(thirdFilterInvRequest.getProductName()) &&
                StrUtil.isEmpty(thirdFilterInvRequest.getDiCode()) &&
                StrUtil.isEmpty(thirdFilterInvRequest.getSupName())) {
            return ResultVOUtils.error(500, "查询条件不能为空！");
        }
        return ResultVOUtils.success(udiwmsClient.postFilterInv(thirdFilterInvRequest));


    }
}

